//
// $Id: fmmouse.h,v 1.2 2001/07/13 15:15:06 nishi Exp $
//
// Copyright (C) 2001 Shouhei Nishi.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 3. The name of author may not be used to endorse or promote products
//    derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.
//

class bx_fmmouse_c : public bx_pad_c {
public:
  virtual ~bx_fmmouse_c(void);

  void virtual init(bx_devices_c *, bx_padport_c *, int);
  Bit8u virtual read(void);
  void virtual write(Bit8u value);

private:
  static unsigned timer_handle;
  static bx_fmmouse_c *activemouse;
  Boolean is_active;
  static void motion_handler(int delta_x, int delta_y, unsigned button_state);
  void motion(int delta_x, int delta_y, unsigned button_state);
  static void timer_handler(void *);
  void timer(void);
  int x,y;
  int button;
  Bit8u lastport;
  Bit8s curx,cury;
  enum {
    NO_START0,
    NO_START1,
    HIGH_X,
    LOW_X,
    HIGH_Y,
    LOW_Y
  } state;
};
